// Buffer class header
#pragma once

#include "VulkanResource.h"

namespace nf::client::render {
    class Buffer : VulkanResource {
    public:
        Buffer(const VkDevice& device, const VkPhysicalDevice& physicalDevice, const VkCommandPool& commandPool, const VkQueue& queue, void* bufferData, size_t bufferSize);

        const VkBuffer& getHandle() const;

        ~Buffer();
    private:
        void createBuffer(VkDeviceSize size, VkBufferUsageFlags usage, VkMemoryPropertyFlags memoryProperties, VkPhysicalDevice physicalDevice, VkBuffer& buffer, VkDeviceMemory& bufferMemory);
        uint32_t findMemoryType(VkPhysicalDevice physicalDevice, uint32_t typeFilter, VkMemoryPropertyFlags properties);
        void copyBuffer(VkBuffer sourceBuffer, VkBuffer destinationBuffer, VkDeviceSize size, VkCommandPool commandPool, VkQueue queue);

        void destroyBuffer(VkBuffer buffer, VkDeviceMemory bufferMemory);

        VkBuffer m_handle;
        VkDeviceMemory m_memory;
    };
}
